#include "libpcap.h"

int cap_fd=-1;

int lpcap_init(void)
{
	struct pcap_file_header phdr;
	
	if ( !flag(FLAG_LIBPCAP) ) return 1;

	cap_fd = open(globals.pcapfile, O_WRONLY | O_CREAT, 00600);
	if ( cap_fd < 0 ) {
		print_err("Error opening tcpdump file" CRLF);
		return 0;
	}

	/* Setup the header */
	phdr.magic = 0xa1b2c3d4;
	phdr.version_major = PCAP_VERSION_MAJOR;
	phdr.version_minor = PCAP_VERSION_MINOR;
	phdr.thiszone = 0;
	phdr.sigfigs = 0;
	phdr.snaplen = BUFFER_SIZE;
	phdr.linktype = DLT_RAW;

	if ( write(cap_fd, &phdr, sizeof(phdr)) < 0 ) {
		perror("writing pcap header");
		return 0;
	}
	
	fsync(cap_fd);

	return 1;
}

void lpcap_close(void)
{
	if ( !flag(FLAG_LIBPCAP) ) return;
	fsync(cap_fd);
	close(cap_fd);
}

void lpcap_dump ( p_packet p )
{
	struct pcap_pkthdr phdr;

	phdr.caplen	= p->data.netlink.len-sizeof(p->data.netlink);
	phdr.len 	= ntohs(p->ip->tot_len);
	gettimeofday( &phdr.ts, NULL );

	write(cap_fd, &phdr, sizeof(phdr) );
	write(cap_fd, p->ip, phdr.caplen );
	fsync(cap_fd);
}
