#include "util.h"

char *strtoupper(char *in)
{
	char *tmp=in;
	
	do {
		*tmp = toupper(*tmp);
	}while ( *(tmp++) != '\0' );
	
	return in;
}

char *get_proto(int p)
{
	struct protoent *proto;

	if ( flag(FLAG_CHROOT) ) {
		switch (p) {
			case 1: return "ICMP";
			case 2: return "IGMP";
			case 6: return "TCP";
			case 17: return "UDP";
		}
	}
	
	proto = getprotobynumber(p);

	if (proto) 	
		return strtoupper(proto->p_name);
	else
		return NULL;
}

int format_ip ( u_long ip, char *txt )
{
	struct in_addr addr;
	addr.s_addr=ip;
	strncpy( txt, inet_ntoa(addr), BUFFER_SIZE );
	return 1;
}

// this is disgusting
int print_icmp_type(u_char type, u_char code)
{
	switch ( type ) {
		case 0:
			print_out("ICMP_ECHO_REPLY");
			return 1;
		case 3:
			switch ( code ){
				case 0:
					print_out("ICMP_NET_UNREACH");
					return 1;
				case 1:
					print_out("ICMP_HOST_UNREACH");
					return 1;
				case 2:
					print_out("ICMP_PROTO_UNREACH");
					return 1;
				case 3:
					print_out("ICMP_PORT_UNREACH");
					return 1;
				case 4:
					print_out("ICMP_FRAG_NEEDED_BUT_DF_SET");
					return 1;
				case 5:
					print_out("ICMP_SOURCE_ROUTE_FAILED");
					return 1;
				case 6:
					print_out("ICMP_NET_UNKNOWN");
					return 1;
				case 7:
					print_out("ICMP_HOST_UNKNOWN");
					return 1;
				case 8:
					print_out("ICMP_SOURCE_HOST_ISOLATED");
					return 1;
				case 9:
					print_out("ICMP_NET_ADMIN_PROHIBITED");
					return 1;
				case 10:
					print_out("ICMP_HOST_ADMIN_PROHIBITED");
					return 1;
				case 11:
					print_out("ICMP_NET_UNREACH_TOS");
					return 1;
				case 12:
					print_out("ICMP_HOST_UNREACH_TOS");
					return 1;
				case 13:
					print_out("ICMP_COMMS_FILTERED");
					return 1;
				case 14:
					print_out("ICMP_PRECEDENCE_VIOLATION");
					return 1;
				case 15:
					print_out("ICMP_PRECEDENCE_CUTOFF");
					return 1;
				default:
					print_out("ICMP_DEST_UNCREACH");
					return 1;
			}
		case 4:
			print_out("ICMP_SOURCE_QUENCH");
			return 1;
		case 5:
			switch ( code ){
				case 0:
					print_out("ICMP_REDIRECT_NET");
					return 1;
				case 1:
					print_out("ICMP_REDIRECT_HOST");
					return 1;
				case 2:
					print_out("ICMP_REDIRECT_TOS_NET");
					return 1;
				case 3:
					print_out("ICMP_REDIRECT_TOS_HOST");
					return 1;
				default:
					print_out("ICMP_REDIRECT");
					return 1;
			}
		case 8:
			print_out("ICMP_ECHO_REQUEST");
			return 1;
		case 9:
			print_out("ICMP_ROUTER_ADVERTISMENT");
			return 1;
		case 10:
			print_out("ICMP_ROUTER_SOLICITATION");
			return 1;
		case 11:
			if ( code == 0 ){
				print_out("ICMP_TTL_EXCEEDED");
			}else if ( code == 1 ){
				print_out("ICMP_TTL_EXCEEDED_IN_REASSEMBLY");
			}else{
				print_out("ICMP_TIME_EXCEED");
			}return 1;
		case 12:
			if ( code == 0 ){
				print_out("ICMP_IP_HEADER_BAD");
			}else if ( code == 1 ){
				print_out("ICMP_IP_OPTION_MISSING");
			}else{
				print_out("ICMP_BAD_PARAM");
			}return 1;
		case 13:
			print_out("ICMP_TIMESTAMP_REQUEST");
			return 1;
		case 14:
			print_out("ICMP_TIMESTAMP_REPLY");
			return 1;
		case 15:
			print_out("ICMP_INFO_REQUEST");
			return 1;
		case 16:
			print_out("ICMP_INFO_REPLY");
			return 1;
		case 17:
			print_out("ICMP_MASK_REQUEST");
			return 1;
		case 18:
			print_out("ICMP_MASK_REPLY");
			return 1;
	}

	print_out("ICMP_UNKNOWN (%.2x:%.2x", type, code);
	return 1;
}
